import pygame

from pykitten.data import *
from pykitten.engine import State

from story import YouWin
from resources import load_mapdata, get_mapnames, SAVE, save_game
from game import CampaignGame


#play all levels in /maps folder in alphabetical order
class Campaign(State):
    def __init__(self, level=0):
        State.__init__(self)

        self.map_list = get_mapnames()

        #set current level
        if level > len(self.map_list):
            level = len(self.map_list) - 1
        self.level = level
        self.done = False

    def update_other(self):
        if self.done is False:
            self.done = True
            self.load_level()

    def load_level(self):
        if SAVE["cur_level"] < self.level:
            SAVE["cur_level"] = self.level
            save_game()
        filename = self.map_list[self.level]
        mapdata = load_mapdata(filename)
        self.next = CampaignGame(mapdata)
        self.pause()
        self.quit()
        #print "Level", self.level, ":", filename


    def unpause(self):
        State.unpause(self)
        self.level += 1
        self.done = False
        if self.level >= len(self.map_list):
            self.next = YouWin()
            self.quit()



