import os
import pygame

from pykitten.data import *

MAP_folder = "custom_maps"
#MAP_folder = "maps"
SAVE = {}


try:
    save = load_object("save.dat")
    for key in save.keys():
        SAVE[key] = save[key]
except:
    SAVE["cur_level"] = 0


def save_game():
    try:
        save_object(SAVE, "save.dat")
    except:
        print "ERROR: Could not save game."


#background images
_names = [
    "levelselect.png",
    "mainscreen.png",
    "credits.png",
]


GFX_bg = {}
_path = filepath("gfx", "menus")
for n in _names:
    GFX_bg[n] = load_image(_path + "/" + n, colorkey=(255,0,255))



#load mapselect file backgrounds
GFX_filebg = []
_path = filepath("gfx", "levelselection")
for i in xrange(1,7):
    GFX_filebg.append(load_image(_path+"/state"+str(i)+".png"))



#load tile graphics
_names = [
    "delete.png",
    "del_pipe.png",
    "del_col.png",
    "block.png",
    "new.png",
    "save.png",
    "load.png",
    "test.png",
    "quit.png",

    "empty.png",

    "btn.png",
    "finish.png",
    "start.png",
    "ground.png",

    "pipe.png",
    "pipe_turn.png",
    "pipe_exit.png",
    "pipe_tjunc.png",
    "pipe_block.png",
    "pipe_sign.png",

    "btn_clr.png",
    "pipe_clr.png",
]

GFX_tiles = {}
_path = filepath("gfx", "tiles")
for n in _names:
    GFX_tiles[n] = load_image(_path+"/"+n, colorkey=(255,0,255))



#generate mini-tiles for preview
_path = filepath("gfx", "mtiles")
GFX_mtiles = {}
for t in GFX_tiles.keys():
    #GFX_mtiles[t] = pygame.transform.scale(GFX_tiles[t], (16,16))
    GFX_mtiles[t] = load_image(_path+"/"+t, colorkey=(255,0,255))

#colors for buttons/junctions
COLORS = [
    (255,0,0), #red
    (0,140,200), #dark blue
    (0,160,0), #dark green
    (254,0,254), #magenta
    (255,200,0), #orange
    #(0,255,255), #turquoise
]

#Mr. Wobbly graphics
GFX_wobbly = {}
GFX_wobbly["stand"] = [
    "blob1.png",
    "blob2.png",
    "blob3.png",
]

GFX_wobbly["move"] = [
    "blobm1.png",
    "blobm2.png",
    "blobm3.png",
]

GFX_wobbly["pipe.png"] = [
    "blobp1.png",
]

GFX_wobbly["pipe_turn.png"] = [
    "blobp2.png",
]

GFX_wobbly["pipe_exit.png"] = [
    "blobp3.png",
]

GFX_wobbly["death"] = [
    "blobd1.png",
    "blobd2.png",
    "blobd3.png",
    "blobd4.png",
    "blobd5.png",
    "blobd6.png",
]


_path = filepath("gfx", "blob")
for key in GFX_wobbly.keys():
    images = []
    for name in GFX_wobbly[key]:
        images.append(load_image(_path+"/"+name, colorkey=(255,0,255)))
    GFX_wobbly[key] = images

GFX_wobbly["move_l"] = []
for img in GFX_wobbly["move"]:
    GFX_wobbly["move_l"].append(pygame.transform.flip(img, 1, 0))



#menu buttons

names = [
    "startgame1.png",
    "startgame2.png",
    "continue1.png",
    "continue2.png",
    "custom1.png",
    "custom2.png",
    "editor1.png",
    "editor2.png",
    "exit1.png",
    "exit2.png",
    "back1.png",
    "back2.png",
    "select1.png",
    "select2.png",
    "next.png",
    "prev.png",
]

_path = filepath("gfx", "buttons")
GFX_menu = {}
for n in names:
    GFX_menu[n] = load_image(_path+"/"+n, colorkey=(255,0,255))







def get_mapnames(folder="maps"):
    #get list of all maps
    map_list = []
    path = filepath(folder)
    files = os.listdir(path)
    for f in files:
        if f.endswith(".map"):
            map_list.append(f)
    map_list.sort()
    return map_list

def load_mapdata(filename, folder="maps"):
    path = filepath(folder, filename)
    mapdata = None
    try:
        mapdata = load_object(path)
    except:
        print "ERROR: Could not load map,", filename

    return mapdata


#placehoders
colors = [(255,0,0),(0,255,0),(0,255,0),(255,255,0),(0,255,255),
    (255,0,255), (150,0,0), (0,150,0), (0,0,150)]

def _gen_placeholder(size, color):
    img = pygame.Surface(size)
    img.fill(color)
    return img



_filenames = [
    "splash.ogg",
    "click.ogg",
]
SFX = load_sfx(_filenames)

#bgm
_music = [
    "bgm.xm",
    "beachwaves.ogg",
]
JB = JukeBox(_music)
